<?php
require_once("../includes/configure.php");
require_once("../includes/database_tables.php");
require_once("../includes/functions/database.php");

	function hmac($algo,$data,$passwd){
	        /* md5 and sha1 only */
	        $algo=strtolower($algo);
	        $p=array('md5'=>'H32','sha1'=>'H40');
	        if(strlen($passwd)>64) $passwd=pack($p[$algo],$algo($passwd));
	        if(strlen($passwd)<64) $passwd=str_pad($passwd,64,chr(0));
	
	        $ipad=substr($passwd,0,64) ^ str_repeat(chr(0x36),64);
	        $opad=substr($passwd,0,64) ^ str_repeat(chr(0x5C),64);
	
	        return($algo($opad.pack($p[$algo],$algo($ipad.$data))));
	}
	
$ENCODED  = $_POST['encoded'];
$CHECKSUM = $_POST['checksum'];

tep_db_connect();
$dbEmail = tep_db_query("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_EPAYBG_ORDER_PAYMENT_EMAIL'");
$dbResult = tep_db_query("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_EPAYBG_SECRET'");
$numRowsSecKey = tep_db_num_rows($dbResult);
$numRowsEmail  =  tep_db_num_rows($dbEmail);
if($numRowsSecKey!=1 || $numRowsSecKey!=1) {
	echo "ERR=Can not get CHECKSUM\n"; # XXX The secret was not stoerd into the database
	tep_db_free_result($dbResult);
	tep_db_free_result($dbEmail);
	tep_db_close();
	exit;
}
$secretKeyArray = tep_db_fetch_array($dbResult);
$emailArray = tep_db_fetch_array($dbEmail);

# XXX Secret word with which merchant make CHECKSUM on the ENCODED packet
$resEmail = $emailArray['configuration_value'];
$secret = $secretKeyArray['configuration_value'];
$hmac   = hmac('sha1', $ENCODED, $secret);

if ($hmac == $CHECKSUM) { # XXX Check if the received CHECKSUM is OK
    
    $data = base64_decode($ENCODED);
    $lines_arr = split("\n", $data);
    $info_data = '';
    
    foreach ($lines_arr as $line) {
        if (preg_match("/^INVOICE=(\d+):STATUS=(PAID|DENIED|EXPIRED)(:PAY_TIME=(\d+):STAN=(\d+):BCODE=([0-9a-zA-Z]+))?$/", $line, $regs)) {
            $invoice  = $regs[1];
            $status   = $regs[2];
            $pay_date = $regs[4]; # XXX if PAID
            $stan     = $regs[5]; # XXX if PAID
            $bcode    = $regs[6]; # XXX if PAID

			$info_data = "INVOICE=$invoice:STATUS=OK\n";
            # XXX if error for this invoice
            # XXX $info_data .= "INVOICE=$invoice:STATUS=ERR\n";

            if( $resEmail!="" ) {
               mail($resEmail,
					"ePay.BG - ".$status,
			 		$invoice." - ".$status." | Transaction: ".$stan." | Borica Code: ".$bcode,
			 		"From: ".$resEmail."\r\nMIME-Version: 1.0\r\n",
			 		"-f".$resEmail);
            }
        }
    }
	tep_db_close();
    echo $info_data, "\n";
}
else {
	tep_db_free_result($dbResult);
	tep_db_free_result($dbEmail);
	tep_db_close();
    echo "ERR=Not valid CHECKSUM\n"; # XXX The description of error is REQUIRED
}
?>