<?php
/*
  Web Hosting and Domain Names - SuperHosting.BG
  http://www.superhosting.bg

  Copyright (c) 2005-2006 NexBrod Technologies LTD

*/

  class epaybg {
    var $code, $title, $description, $enabled;

// class constructor
    function epaybg() {
      global $order;

      $this->code = 'epaybg';
      $this->title = MODULE_PAYMENT_EPAYBG_TEXT_TITLE;
      $this->description = MODULE_PAYMENT_EPAYBG_TEXT_DESCRIPTION;
      $this->sort_order = MODULE_PAYMENT_EPAYBG_SORT_ORDER;
      $this->enabled = ((MODULE_PAYMENT_EPAYBG_STATUS == 'True') ? true : false);

      if ((int)MODULE_PAYMENT_EPAYBG_ORDER_STATUS_ID > 0) {
        $this->order_status = MODULE_PAYMENT_EPAYBG_ORDER_STATUS_ID;
      }

      if (is_object($order)) $this->update_status();

      $this->form_action_url = MODULE_PAYMENT_EPAYBG_URL;
    }

// class methods
    function update_status() {
      global $order;

      if ( ($this->enabled == true) && ((int)MODULE_PAYMENT_EPAYBG_ZONE > 0) ) {
        $check_flag = false;
        $check_query = tep_db_query("select zone_id from " . TABLE_ZONES_TO_GEO_ZONES . " where geo_zone_id = '" . MODULE_PAYMENT_2CHECKOUT_ZONE . "' and zone_country_id = '" . $order->billing['country']['id'] . "' order by zone_id");
        while ($check = tep_db_fetch_array($check_query)) {
          if ($check['zone_id'] < 1) {
            $check_flag = true;
            break;
          } elseif ($check['zone_id'] == $order->billing['zone_id']) {
            $check_flag = true;
            break;
          }
        }

        if ($check_flag == false) {
          $this->enabled = false;
        }
      }
    }

    function javascript_validation() {
      return false;
    }

    function selection() {
      global $order;

      $selection = array('id' => $this->code,
                         'module' => $this->title);

      return $selection;
    }

    function pre_confirmation_check() {
      return false;
    }

    function confirmation() {
      global $HTTP_POST_VARS;
      $confirmation = array('title' => MODULE_PAYMENT_EPAYBG_TEXT_TITLE);
      return $confirmation;
    }

     function hmac($algo,$data,$passwd){
		
	        /* md5 and sha1 only */
	        $algo=strtolower($algo);
	        $p=array('md5'=>'H32','sha1'=>'H40');
	        if(strlen($passwd)>64) $passwd=pack($p[$algo],$algo($passwd));
	        if(strlen($passwd)<64) $passwd=str_pad($passwd,64,chr(0));
	
	        $ipad=substr($passwd,0,64) ^ str_repeat(chr(0x36),64);
	        $opad=substr($passwd,0,64) ^ str_repeat(chr(0x5C),64);
	
	        return($algo($opad.pack($p[$algo],$algo($ipad.$data))));
	}
    
	function getInvoiceNumber() {
		global $cart;
		return 	$cart->cartID;
	}
    
    function process_button() {
      global $HTTP_POST_VARS, $order;

     
	$secret     = MODULE_PAYMENT_EPAYBG_SECRET; // SET this correct
	$min        = MODULE_PAYMENT_EPAYBG_KIN;    // Merchant Identification Number,  SET this correct
	$invoice    = $this->getInvoiceNumber(); 				// Invoice Order Number
	$sum        = number_format($order->info['total'], 2, ".", ""); 		// Ammount
	$tmoValidDays = MODULE_PAYMENT_EPAYBG_ORDER_VALIDTO;
	if( $tmoValidDays==0 )
		$tmoValidDays = 1;
	$nextValidDate=time() +($tmoValidDays*24 * 60 * 60);
	$localDate = date("d.m.Y", $nextValidDate);
	$exp_date   = $localDate;                      	 // Expiration date
	$descr      = MODULE_PAYMENT_EPAYBG_DESCRIPTION; // Description

$data = <<<DATA
MIN={$min}
INVOICE={$invoice}
AMOUNT={$sum}
EXP_TIME={$exp_date}
DESCR={$descr}
DATA;

	$ENCODED  = base64_encode($data);
	$CHECKSUM = $this->hmac('sha1', $ENCODED, $secret);
      
    $process_button_string = tep_draw_hidden_field('PAGE', 'paylogin') .
                             tep_draw_hidden_field('ENCODED', $ENCODED) .
                             tep_draw_hidden_field('CHECKSUM', $CHECKSUM).
                             tep_draw_hidden_field('URL_OK', tep_href_link(FILENAME_CHECKOUT_PROCESS, '', 'NONSSL')).
                             tep_draw_hidden_field('URL_CANCEL', tep_href_link(FILENAME_CHECKOUT_PROCESS, '', 'NONSSL'));
      
      return $process_button_string;
    }

    function before_process() {
      global $HTTP_POST_VARS;
      return false;

    }

    function after_process() {
      return false;
    }

    function get_error() {
      global $HTTP_GET_VARS;

      $error = array('title' => MODULE_PAYMENT_EPAYBG_TEXT_ERROR,
                     'error' => stripslashes(urldecode($HTTP_GET_VARS['error'])));

      return $error;
    }

    function check() {
      if (!isset($this->_check)) {
        $check_query = tep_db_query("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_EPAYBG_STATUS'");
        $this->_check = tep_db_num_rows($check_query);
      }
      return $this->_check;
    }

    function install() {
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('      ePay.BG.' , 'MODULE_PAYMENT_EPAYBG_STATUS', 'True', '        ePay.BG?', '6', '0', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('   ePay.BG.', 'MODULE_PAYMENT_EPAYBG_KIN', 'D480217173', '     ePay.BG', '6', '0', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('   ePay.BG.', 'MODULE_PAYMENT_EPAYBG_SECRET', 'PDLC8TE10GE5KKD3MZ547S3ZGN9LNLY2PVEHBSF75YWLOX70VKQDQPFTND8CFLDB', ',          .    ePay.BG    a .', '6', '0', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order,  set_function, date_added) values ('ePay.BG URL.', 'MODULE_PAYMENT_EPAYBG_URL', 'https://devep2.datamax.bg/ep2/epay2_demo/', 'URL  ePay.BG,    ', '6', '0' , 'tep_cfg_select_option(array(\'https://devep2.datamax.bg/ep2/epay2_demo/\', \'https://www.epay.bg/\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('  .', 'MODULE_PAYMENT_EPAYBG_ORDER_VALIDTO', '0', '            .    .', '6', '0', now())");
	  tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('  .', 'MODULE_PAYMENT_EPAYBG_DESCRIPTION', '   ', ' ,    ,    .<br/>,     .', '6', '0', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('    .', 'MODULE_PAYMENT_EPAYBG_SORT_ORDER', '0', '    . -  -  -', '6', '0', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values (' .', 'MODULE_PAYMENT_EPAYBG_ZONE', '0', '  ,     ePay      ..', '6', '2', 'tep_get_zone_class_title', 'tep_cfg_pull_down_zone_classes(', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('  .', 'MODULE_PAYMENT_EPAYBG_ORDER_STATUS_ID', '0', '  ,      ePay.BG', '6', '0', 'tep_cfg_pull_down_order_statuses(', 'tep_get_order_status_name', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('E-Mail  .', 'MODULE_PAYMENT_EPAYBG_ORDER_PAYMENT_EMAIL', 'drenovski@superhosting.bg', 'E-Mail            ePay.BG    ', '6', '0', now())");
      $this->createOrderFields();
    }

    function createOrderFields() {
		tep_db_query("ALTER TABLE ". TABLE_ORDERS ." ADD cart_id VARCHAR( 100 ) CHARACTER SET cp1251 COLLATE cp1251_bulgarian_ci NULL");    	
    }
    
    function remove() {		
    	$this->removeOrderFields();
      	tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }

    function removeOrderFields() {
    	tep_db_query("ALTER TABLE ".TABLE_ORDERS ." DROP cart_id");
    }
    
    function keys() {
      return array('MODULE_PAYMENT_EPAYBG_STATUS', 'MODULE_PAYMENT_EPAYBG_KIN', 'MODULE_PAYMENT_EPAYBG_URL', 
      			'MODULE_PAYMENT_EPAYBG_SECRET', 'MODULE_PAYMENT_EPAYBG_ZONE', 'MODULE_PAYMENT_EPAYBG_SORT_ORDER', 
      			'MODULE_PAYMENT_EPAYBG_ORDER_STATUS_ID','MODULE_PAYMENT_EPAYBG_ORDER_VALIDTO','MODULE_PAYMENT_EPAYBG_DESCRIPTION',
      			'MODULE_PAYMENT_EPAYBG_ORDER_PAYMENT_EMAIL');
    }
  }
?>